using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Cyberbots2349
{
    abstract class Characters
    {
        public Texture2D sprite;    //the texture for the sprites
        public Vector2 position;    //position of sprites on screen
        public float rotation;      //rotation angle
        public Vector2 center;      //center of sprites
        public Vector2 velocity;    //sprite's movement speed
        public int life;            //sprite's life, for robots and humans
        public bool faction;        //for laser ownership
        public int timer;           //zapper shoot timer and human move time
    }

    class Alien : Characters
    {
        public Alien(Texture2D loadedTexture)
        {
            rotation = 0.0f;
            sprite = loadedTexture;
            center = new Vector2(sprite.Width / 2, sprite.Height / 2);
            velocity = new Vector2(10, 10);
        }
    }

    class Laser : Characters
    {
        public Laser(Texture2D loadedTexture)
        {
            rotation = 0.0f;
            sprite = loadedTexture;
            center = new Vector2(sprite.Width / 2, sprite.Height / 2);
            velocity = new Vector2(30, 30);
            life = 0;
        }
    }

    class Laser1 : Characters
    {
        public Laser1(Texture2D loadedTexture)
        {
            sprite = loadedTexture;
            center = new Vector2(sprite.Width / 2, sprite.Height / 2);
        }
    }

    class Laser2 : Characters
    {
        public Laser2(Texture2D loadedTexture)
        {
            sprite = loadedTexture;
            center = new Vector2(sprite.Width / 2, sprite.Height / 2);
        }
    }

    class Human : Characters
    {
        public Human(Texture2D loadedTexture)
        {
            rotation = 0.0f;
            sprite = loadedTexture;
            center = new Vector2(sprite.Width / 2, sprite.Height / 2);
            velocity = new Vector2(15, 15);
            life = 0;
            timer = 0;
        }
    }

    class Chaser : Characters
    {
        public Chaser(Texture2D loadedTexture)
        {
            rotation = 0.0f;
            sprite = loadedTexture;
            center = new Vector2(sprite.Width / 2, sprite.Height / 2);
            velocity = new Vector2(18, 18);
            life = 0;
            timer = 0;
        }
    }

    class StrongChaser : Characters
    {
        public StrongChaser(Texture2D loadedTexture)
        {
            rotation = 0.0f;
            sprite = loadedTexture;
            center = new Vector2(sprite.Width / 2, sprite.Height / 2);
            velocity = new Vector2(18, 18);
            life = 0;
            timer = 0;
        }
    }

    class FastChaser : Characters
    {
        public FastChaser(Texture2D loadedTexture)
        {
            rotation = 0.0f;
            sprite = loadedTexture;
            center = new Vector2(sprite.Width / 2, sprite.Height / 2);
            velocity = new Vector2(18, 18);
            life = 0;
            timer = 0;
        }
    }

    class Titan : Characters
    {
        public Titan(Texture2D loadedTexture)
        {
            rotation = 0.0f;
            sprite = loadedTexture;
            center = new Vector2(sprite.Width / 2, sprite.Height / 2);
            velocity = new Vector2(10, 10);
            life = 0;
            timer = 0;
        }
    }

    class Zapper : Characters
    {
        public Zapper(Texture2D loadedTexture)
        {
            rotation = 0.0f;
            sprite = loadedTexture;
            center = new Vector2(sprite.Width / 2, sprite.Height / 2);
            velocity = new Vector2(24, 24);
            life = 0;
            timer = 0;
        }
    }
}